import { MixinTarget } from '@loopback/core';
import { EntityCrudRepository } from '@loopback/repository';
import { QueryMixinOptions } from '../mixins';
/**
 * A decorator to mixin Query to a EntityCrudRepository
 */
export declare function mixinQuery(options?: boolean | QueryMixinOptions): <T extends MixinTarget<EntityCrudRepository<any, any>>>(superClass: T) => {
    new (...args: any[]): {
        __query__?: import("..").Query<import("@loopback/repository").Entity, object> | null | undefined;
        readonly query: import("..").Query<import("@loopback/repository").Entity, object> | null | undefined;
        find(filter?: import("..").QueryFilter<import("@loopback/repository").Entity> | undefined, options?: object): Promise<(import("@loopback/repository").Entity & object)[]>;
        findOne(filter?: import("..").QueryFilter<import("@loopback/repository").Entity> | undefined, options?: object): Promise<(import("@loopback/repository").Entity & object) | null>;
        count(where?: import("..").QueryWhere<import("@loopback/repository").Entity> | undefined, options?: object): Promise<{
            count: number;
        }>;
        entityClass: typeof import("@loopback/repository").Entity & {
            prototype: import("@loopback/repository").Entity;
        };
        inclusionResolvers: Map<string, import("@loopback/repository").InclusionResolver<import("@loopback/repository").Entity, import("@loopback/repository").Entity>>;
        save: (entity: import("@loopback/repository").DataObject<import("@loopback/repository").Entity>, options?: import("@loopback/repository").Options) => Promise<import("@loopback/repository").Entity>;
        update: (entity: import("@loopback/repository").DataObject<import("@loopback/repository").Entity>, options?: import("@loopback/repository").Options) => Promise<void>;
        delete: (entity: import("@loopback/repository").DataObject<import("@loopback/repository").Entity>, options?: import("@loopback/repository").Options) => Promise<void>;
        findById: (id: unknown, filter?: import("@loopback/repository").FilterExcludingWhere<import("@loopback/repository").Entity> | undefined, options?: import("@loopback/repository").Options) => Promise<import("@loopback/repository").Entity & object>;
        updateById: (id: unknown, data: import("@loopback/repository").DataObject<import("@loopback/repository").Entity>, options?: import("@loopback/repository").Options) => Promise<void>;
        replaceById: (id: unknown, data: import("@loopback/repository").DataObject<import("@loopback/repository").Entity>, options?: import("@loopback/repository").Options) => Promise<void>;
        deleteById: (id: unknown, options?: import("@loopback/repository").Options) => Promise<void>;
        exists: (id: unknown, options?: import("@loopback/repository").Options) => Promise<boolean>;
        execute: (command: import("@loopback/repository").Command, parameters: import("@loopback/repository").NamedParameters | import("@loopback/repository").PositionalParameters, options?: import("@loopback/repository").Options) => Promise<import("@loopback/repository").AnyObject>;
        create: (dataObject: import("@loopback/repository").DataObject<import("@loopback/repository").Entity>, options?: import("@loopback/repository").Options) => Promise<import("@loopback/repository").Entity>;
        createAll: (dataObjects: import("@loopback/repository").DataObject<import("@loopback/repository").Entity>[], options?: import("@loopback/repository").Options) => Promise<import("@loopback/repository").Entity[]>;
        updateAll: (dataObject: import("@loopback/repository").DataObject<import("@loopback/repository").Entity>, where?: import("@loopback/repository").Where<import("@loopback/repository").Entity> | undefined, options?: import("@loopback/repository").Options) => Promise<import("@loopback/repository").Count>;
        deleteAll: (where?: import("@loopback/repository").Where<import("@loopback/repository").Entity> | undefined, options?: import("@loopback/repository").Options) => Promise<import("@loopback/repository").Count>;
    };
} & T;
