import { AnyObject, Entity, Filter, juggler, Options } from '@loopback/repository';
import { QueryFilter, QueryWhere } from './filter';
import { Orm } from './orm';
import { EntityClass, IdSort } from './types';
export declare abstract class Driver {
    readonly dataSource: juggler.DataSource;
    options: Options;
    protected orm: Orm;
    constructor(dataSource: juggler.DataSource, options?: Options);
    abstract find<T extends Entity>(model: EntityClass<T>, filter?: QueryFilter<T>, options?: Options): Promise<AnyObject[]>;
    abstract count<T extends Entity>(model: EntityClass<T>, where?: QueryWhere<T>, options?: Options): Promise<{
        count: number;
    }>;
    protected init(): void;
    protected applySortPolicy(model: EntityClass, filter: Filter): void;
    protected getDefaultIdSortPolicy(model: EntityClass): IdSort;
    protected hasOnlyNumericIds(model: EntityClass): boolean;
}
