"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.loadDriver = loadDriver;
const object_1 = require("tily/is/object");
const string_1 = require("tily/is/string");
function loadDriver(ds) {
    var _a, _b;
    let options = {};
    const query = ds.settings.query;
    if ((0, string_1.isString)(query)) {
        options = { driver: query };
    }
    else if ((0, object_1.isObject)(query)) {
        options = { ...query };
    }
    options.driver = (_a = options.driver) !== null && _a !== void 0 ? _a : 'sql';
    const driver = options.driver;
    const mod = require(`./drivers/${driver}`);
    const driverClass = (_b = mod.default) !== null && _b !== void 0 ? _b : mod;
    return new driverClass(ds, options);
}
//# sourceMappingURL=driver.loader.js.map