import { Filter } from '@loopback/filter';
import { Entity, juggler } from '@loopback/repository';
import { Knex } from 'knex';
import { Orm } from '../../orm';
import { QuerySession } from '../../session';
import { EntityClass } from '../../types';
export declare class ClauseResolver<TModel extends Entity> {
    entityClass: EntityClass<TModel>;
    readonly orm: Orm;
    constructor(entityClass: EntityClass<TModel>, orm: Orm | juggler.DataSource);
    resolve(qb: Knex.QueryBuilder<TModel>, filter: Filter<TModel>, session: QuerySession): void;
    tableEscaped(): string;
    columnEscaped(columnName: string, withTable?: boolean, prefix?: string): string;
}
