import { juggler } from '@loopback/repository';
import { Knex } from 'knex';
import Client = Knex.Client;
export declare const KnexSupportedClients: {
    MsSQL: string;
    MySQL: string;
    MySQL2: string;
    Oracle: string;
    PostgreSQL: string;
    PgNative: string;
    Redshift: string;
    SQLite: string;
    CockroachDB: string;
    BetterSQLite3: string;
};
export declare const KnexSupportedClientRegexps: {
    [x: string]: RegExp;
};
export interface KenxCreationOptions {
    client?: string | typeof Client;
}
export interface KnexQueryContext {
    skipEscape: boolean;
}
export declare function createKnex<TRecord extends {} = any, TResult = unknown[]>(ds: juggler.DataSource, options?: KenxCreationOptions): Knex<TRecord, TResult>;
