import { Entity, ModelDefinition } from '@loopback/repository';
import { Knex } from 'knex';
import { QueryFilter } from '../../../filter';
import { RelationConstraint } from '../../../relation';
import { QuerySession } from '../../../session';
import { ClauseResolver } from '../clause';
export declare class JoinResolver<TModel extends Entity> extends ClauseResolver<TModel> {
    resolve(qb: Knex.QueryBuilder<TModel>, filter: QueryFilter<TModel>, session?: QuerySession): void;
    protected buildJoins(qb: Knex.QueryBuilder, session: QuerySession): void;
    protected compile(key: string, session: QuerySession, constraints: Record<string, RelationConstraint>): void;
}
export declare function parseRelationChain(definition: ModelDefinition, key: string): {
    relationChain: Member[];
    property?: undefined;
    propertyKey?: undefined;
} | {
    relationChain: Member[];
    property: import("@loopback/repository").PropertyDefinition;
    propertyKey: string;
} | undefined;
interface Member {
    name: string;
    polymorphicValue?: string;
}
export {};
