"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.OrderResolver = void 0;
const tslib_1 = require("tslib");
/* eslint-disable @typescript-eslint/no-floating-promises */
const filter_1 = require("@loopback/filter");
const toArray_1 = tslib_1.__importDefault(require("tily/array/toArray"));
const assert_1 = require("tily/assert");
const clause_1 = require("../clause");
class OrderResolver extends clause_1.ClauseResolver {
    resolve(qb, filter, session) {
        const orders = (0, toArray_1.default)((0, filter_1.isFilter)(filter) ? filter.order : filter);
        const relationOrder = session.relationOrder;
        for (const order of orders) {
            const parts = order.split(/[\s,]+/);
            const [key, value] = parts;
            if (relationOrder[key]) {
                const constraint = relationOrder[key];
                (0, assert_1.assert)(constraint.property, `Relation order constraint for key '${key}' is missing property`);
                qb.orderBy(this.orm.columnEscaped(constraint.model, constraint.property.key, true, constraint.prefix), value);
            }
            else {
                qb.orderBy(this.columnEscaped(key, true), value);
            }
        }
    }
}
exports.OrderResolver = OrderResolver;
//# sourceMappingURL=order.js.map