import { Filter } from '@loopback/filter';
import { AnyObject, Entity, Options } from '@loopback/repository';
import { Knex } from 'knex';
import { Driver } from '../../driver';
import { QueryFilter, QueryWhere } from '../../filter';
import { QuerySession } from '../../session';
import { EntityClass } from '../../types';
import { StatementResolvers } from './statement';
export declare class SqlDriver extends Driver {
    protected knex: Knex;
    protected resolvers: StatementResolvers;
    find<T extends Entity>(model: EntityClass<T>, filter?: QueryFilter<T>, options?: Options): Promise<AnyObject[]>;
    count<T extends Entity>(model: EntityClass<T>, where?: QueryWhere<T>, options?: Options): Promise<{
        count: number;
    }>;
    protected init(): void;
    protected buildSelect<T extends Entity = Entity>(model: EntityClass<T>, filter: QueryFilter<T>): [Knex.QueryBuilder, QuerySession];
    protected resolveLimit(qb: Knex.QueryBuilder, filter: Filter): void;
}
