import { Entity } from '@loopback/repository';
import { Knex } from 'knex';
import { QueryFilter } from '../../filter';
import { Orm } from '../../orm';
import { QuerySession } from '../../session';
import { EntityClass } from '../../types';
import { ColumnsResolver, JoinResolver, OrderResolver, WhereResolver } from './resolvers';
export declare class StatementResolver<T extends Entity = Entity> {
    readonly model: EntityClass<T>;
    orm: Orm;
    readonly columns: ColumnsResolver<T>;
    readonly join: JoinResolver<T>;
    readonly where: WhereResolver<T>;
    readonly order: OrderResolver<T>;
    constructor(model: EntityClass<T>, orm: Orm);
    resolveColumns(qb: Knex.QueryBuilder, filter: QueryFilter<T>): void;
    resolveJoin(qb: Knex.QueryBuilder, filter: QueryFilter<T>, session: QuerySession): void;
    resolveWhere(qb: Knex.QueryBuilder, filter: QueryFilter<T>, session: QuerySession): void;
    resolveOrder(qb: Knex.QueryBuilder, filter: QueryFilter<T>, session: QuerySession): void;
}
export declare class StatementResolvers {
    orm: Orm;
    protected items: Map<string, StatementResolver>;
    constructor(orm: Orm);
    get<T extends Entity = Entity>(model: EntityClass<T>): StatementResolver<T>;
}
