"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.queryUnpatch = queryUnpatch;
exports.queryPatch = queryPatch;
const constructor_1 = require("tily/is/constructor");
const function_1 = require("tily/is/function");
const query_1 = require("../query");
const utils_1 = require("../utils");
const debug = require('debug')('bleco:query:patch');
function queryUnpatch(repo) {
    const target = (0, constructor_1.isConstructor)(repo) ? repo.prototype : repo;
    if (target.__getQuery__) {
        delete target.__getQuery__;
        if (target.__query__) {
            delete target.__query__;
        }
        for (const method of query_1.QueryMethods) {
            if (target[(0, utils_1.originalProp)(method)]) {
                target[method] = target[(0, utils_1.originalProp)(method)];
                delete target[(0, utils_1.originalProp)(method)];
            }
        }
    }
}
function queryPatch(repo) {
    const target = (0, constructor_1.isConstructor)(repo) ? repo.prototype : repo;
    if (!target || !(0, function_1.isFunction)(target.find)) {
        return false;
    }
    if (!target.__getQuery__) {
        target.__getQuery__ = function () {
            if (this.__query__ === undefined && this.dataSource) {
                try {
                    this.__query__ = new query_1.DefaultQuery(this);
                }
                catch (e) {
                    this.__query__ = null;
                }
            }
            return this.__query__;
        };
        for (const method of query_1.QueryMethods) {
            if (target[method] && !target[(0, utils_1.originalProp)(method)]) {
                target[(0, utils_1.originalProp)(method)] = target[method];
                target[method] = function (...args) {
                    const query = this.__getQuery__();
                    if (query) {
                        debug(`${this.constructor.name} ${method}() -> query.${method}()`);
                        return query[method](...args);
                    }
                    debug(`${this.constructor.name} ${method}() -> super.${method}()`);
                    return this[(0, utils_1.originalProp)(method)](...args);
                };
            }
        }
        return true;
    }
    return null;
}
//# sourceMappingURL=query.patch.js.map