import { BelongsToDefinition, HasManyDefinition, HasOneDefinition, PropertyDefinition, RelationType } from '@loopback/repository';
export type QueryRelationMetadata = HasManyDefinition | BelongsToDefinition | HasOneDefinition;
export interface RelationJoin {
    prefix: string;
    parentPrefix: string;
    relationPath: string;
    parentModel: string;
    relation: QueryRelationMetadata;
    model: string;
    polymorphic?: {
        discriminator: string;
        value?: string;
    };
}
export interface RelationConstraint {
    prefix: string;
    model: string;
    property?: Partial<PropertyDefinition>;
}
export declare const SupportedRelationTypes: RelationType[];
export declare function resolveRelation(relation: QueryRelationMetadata): QueryRelationMetadata;
