"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SupportedRelationTypes = void 0;
exports.resolveRelation = resolveRelation;
const repository_1 = require("@loopback/repository");
const belongs_to_helpers_1 = require("@loopback/repository/dist/relations/belongs-to/belongs-to.helpers");
const has_many_helpers_1 = require("@loopback/repository/dist/relations/has-many/has-many.helpers");
const has_many_through_helpers_1 = require("@loopback/repository/dist/relations/has-many/has-many-through.helpers");
const has_one_helpers_1 = require("@loopback/repository/dist/relations/has-one/has-one.helpers");
exports.SupportedRelationTypes = [repository_1.RelationType.hasMany, repository_1.RelationType.belongsTo, repository_1.RelationType.hasOne];
function resolveRelation(relation) {
    if (relation.type === repository_1.RelationType.belongsTo) {
        relation = (0, belongs_to_helpers_1.resolveBelongsToMetadata)(relation);
    }
    else if (relation.type === repository_1.RelationType.hasOne) {
        relation = (0, has_one_helpers_1.resolveHasOneMetadata)(relation);
    }
    else if (relation.type === repository_1.RelationType.hasMany) {
        if (relation.through) {
            relation = (0, has_many_through_helpers_1.resolveHasManyThroughMetadata)(relation);
        }
        else {
            relation = (0, has_many_helpers_1.resolveHasManyMetadata)(relation);
        }
    }
    return relation;
}
//# sourceMappingURL=relation.js.map