import { DefaultCrudRepository, DefaultTransactionalRepository, Entity } from '@loopback/repository';
import { QueryEnhancedRepository } from './mixins';
/**
 * Query enhanced repository with default CRUD methods overwritten
 */
export declare class QueryEnhancedCrudRepository<T extends Entity, ID, Relations extends object = {}> extends DefaultCrudRepository<T, ID, Relations> {
}
export interface QueryEnhancedCrudRepository<T extends Entity, ID, Relations extends object = {}> extends QueryEnhancedRepository<T, Relations> {
}
/**
 * Query enhanced transactional repository with default CRUD methods overwritten
 */
export declare class QueryEnhancedTransactionalCrudRepository<T extends Entity, ID, Relations extends object = {}> extends DefaultTransactionalRepository<T, ID, Relations> {
}
export interface QueryEnhancedTransactionalCrudRepository<T extends Entity, ID, Relations extends object = {}> extends QueryEnhancedRepository<T, Relations> {
}
/**
 * Query enhanced repository without overwriting the default CRUD methods
 */
export declare class CrudRepositoryWithQuery<T extends Entity, ID, Relations extends object = {}> extends DefaultCrudRepository<T, ID, Relations> {
}
export interface CrudRepositoryWithQuery<T extends Entity, ID, Relations extends object = {}> extends QueryEnhancedRepository<T, Relations> {
}
/**
 * Query enhanced transactional repository without overwriting the default CRUD methods
 */
export declare class TransactionalCrudRepositoryWithQuery<T extends Entity, ID, Relations extends object = {}> extends DefaultTransactionalRepository<T, ID, Relations> {
}
export interface TransactionalCrudRepositoryWithQuery<T extends Entity, ID, Relations extends object = {}> extends QueryEnhancedRepository<T, Relations> {
}
