"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.TransactionalCrudRepositoryWithQuery = exports.CrudRepositoryWithQuery = exports.QueryEnhancedTransactionalCrudRepository = exports.QueryEnhancedCrudRepository = void 0;
const tslib_1 = require("tslib");
const repository_1 = require("@loopback/repository");
const decorators_1 = require("./decorators");
/**
 * Query enhanced repository with default CRUD methods overwritten
 */
let QueryEnhancedCrudRepository = class QueryEnhancedCrudRepository extends repository_1.DefaultCrudRepository {
};
exports.QueryEnhancedCrudRepository = QueryEnhancedCrudRepository;
exports.QueryEnhancedCrudRepository = QueryEnhancedCrudRepository = tslib_1.__decorate([
    (0, decorators_1.mixinQuery)(true)
], QueryEnhancedCrudRepository);
/**
 * Query enhanced transactional repository with default CRUD methods overwritten
 */
let QueryEnhancedTransactionalCrudRepository = class QueryEnhancedTransactionalCrudRepository extends repository_1.DefaultTransactionalRepository {
};
exports.QueryEnhancedTransactionalCrudRepository = QueryEnhancedTransactionalCrudRepository;
exports.QueryEnhancedTransactionalCrudRepository = QueryEnhancedTransactionalCrudRepository = tslib_1.__decorate([
    (0, decorators_1.mixinQuery)(true)
], QueryEnhancedTransactionalCrudRepository);
/**
 * Query enhanced repository without overwriting the default CRUD methods
 */
let CrudRepositoryWithQuery = class CrudRepositoryWithQuery extends repository_1.DefaultCrudRepository {
};
exports.CrudRepositoryWithQuery = CrudRepositoryWithQuery;
exports.CrudRepositoryWithQuery = CrudRepositoryWithQuery = tslib_1.__decorate([
    (0, decorators_1.mixinQuery)()
], CrudRepositoryWithQuery);
/**
 * Query enhanced transactional repository without overwriting the default CRUD methods
 */
let TransactionalCrudRepositoryWithQuery = class TransactionalCrudRepositoryWithQuery extends repository_1.DefaultTransactionalRepository {
};
exports.TransactionalCrudRepositoryWithQuery = TransactionalCrudRepositoryWithQuery;
exports.TransactionalCrudRepositoryWithQuery = TransactionalCrudRepositoryWithQuery = tslib_1.__decorate([
    (0, decorators_1.mixinQuery)()
], TransactionalCrudRepositoryWithQuery);
//# sourceMappingURL=repository.js.map