import { RelationConstraint, RelationJoin } from './relation';
export interface QuerySessionData {
    relationJoins?: RelationJoin[];
    relationWhere?: Record<string, RelationConstraint>;
    relationOrder?: Record<string, RelationConstraint>;
}
export declare class QuerySession {
    readonly relationJoins: RelationJoin[];
    readonly relationWhere: Record<string, RelationConstraint>;
    readonly relationOrder: Record<string, RelationConstraint>;
    private _seq;
    static create(sessionOrData?: QuerySession | QuerySessionData): QuerySession;
    protected constructor(data?: QuerySessionData);
    currentSeq(): number;
    nextSeq(): number;
    hasRelations(): boolean;
    hasRelationJoins(): boolean;
    hasRelationWhere(): boolean;
    hasRelationOrder(): boolean;
    addRelationJoin(join: RelationJoin): RelationJoin;
    setRelationWhere(key: string, constraint: RelationConstraint): void;
    setRelationOrder(key: string, constraint: RelationConstraint): void;
}
