"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.QuerySession = void 0;
class QuerySession {
    static create(sessionOrData) {
        return sessionOrData instanceof QuerySession ? sessionOrData : new QuerySession(sessionOrData);
    }
    constructor(data) {
        var _a, _b, _c;
        this._seq = 0;
        this.relationJoins = (_a = data === null || data === void 0 ? void 0 : data.relationJoins) !== null && _a !== void 0 ? _a : [];
        this.relationWhere = (_b = data === null || data === void 0 ? void 0 : data.relationWhere) !== null && _b !== void 0 ? _b : {};
        this.relationOrder = (_c = data === null || data === void 0 ? void 0 : data.relationOrder) !== null && _c !== void 0 ? _c : {};
    }
    currentSeq() {
        return this._seq;
    }
    nextSeq() {
        return this._seq++;
    }
    hasRelations() {
        return this.hasRelationJoins() || this.hasRelationWhere() || this.hasRelationOrder();
    }
    hasRelationJoins() {
        return this.relationJoins.length > 0;
    }
    hasRelationWhere() {
        return Object.keys(this.relationWhere).length > 0;
    }
    hasRelationOrder() {
        return Object.keys(this.relationOrder).length > 0;
    }
    addRelationJoin(join) {
        this.relationJoins.push(join);
        return join;
    }
    setRelationWhere(key, constraint) {
        this.relationWhere[key] = constraint;
    }
    setRelationOrder(key, constraint) {
        this.relationOrder[key] = constraint;
    }
}
exports.QuerySession = QuerySession;
//# sourceMappingURL=session.js.map