"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.originalProp = void 0;
exports.omit = omit;
exports.compactWhere = compactWhere;
exports.isDataSource = isDataSource;
exports.isSqlConnector = isSqlConnector;
exports.isMapper = isMapper;
exports.isNested = isNested;
const tslib_1 = require("tslib");
const array_1 = tslib_1.__importDefault(require("tily/is/array"));
const empty_1 = tslib_1.__importDefault(require("tily/is/empty"));
const string_1 = tslib_1.__importDefault(require("tily/is/string"));
const each_1 = tslib_1.__importDefault(require("tily/object/each"));
function omit(obj, fn) {
    const result = {};
    (0, each_1.default)((v, k) => {
        if (!fn(v)) {
            result[k] = v;
        }
    }, obj);
    return result;
}
function compactWhere(where) {
    return omit(where, v => v === undefined || (((0, array_1.default)(v) || (0, string_1.default)(v)) && (0, empty_1.default)(v)));
}
// eslint-disable-next-line @typescript-eslint/no-explicit-any
function isDataSource(x) {
    return x && typeof x === 'object' && typeof x.connect === 'function' && typeof x.discoverSchemas === 'function';
}
// eslint-disable-next-line @typescript-eslint/no-explicit-any
function isSqlConnector(x) {
    return (x &&
        typeof x === 'object' &&
        typeof x.tableEscaped === 'function' &&
        typeof x.columnEscaped === 'function' &&
        typeof x.autoupdate === 'function');
}
// eslint-disable-next-line @typescript-eslint/no-explicit-any
function isMapper(x) {
    return x && typeof x.column === 'function' && typeof x.table === 'function' && !isDataSource(x) && !isSqlConnector(x);
}
/**
 * Check if a value is attempting to use nested json keys
 * @param {String} key The property being queried from where clause
 * @returns {Boolean} True of the property contains dots for nested json
 */
function isNested(key) {
    return key.split('.').length > 1;
}
const originalProp = (method) => `__${method}__`;
exports.originalProp = originalProp;
//# sourceMappingURL=utils.js.map